'GeoScript: Demonstrations of Conic Sections

'TO DO: more detailled explanation of constructions (with drawings).

SCREEN 760,600
SPEED 300
TITLE "Conic Sections"

CLS 0
WINDOW 760,380
CONSTRUCT MainTitle FAST
CONSTRUCT Instructions
TEXTWINDOW 100,520, 550,20
TEXT "Click 'Resume' or press [Enter] to continue.", &HFFFFFF, 0
ANIMATE aTitle FAST
'No WAIT necessary here, ANIMATION WAITs when finished.

'Restore the title because it disappears after the ANIMATION finishes.
  MARKPOINT Conic, 64
  MARKPOINT Sections, 64

WINDOW 760,600
'Restore the text because the larger WINDOW covered it:
CONSTRUCT Instructions

MENU
MENUITEM "General Demonstration of Conic Sections (stereometric)"
  CLS
  CONSTRUCT InitSections FAST
  fillP = COPY LbottomL
  CONSTRUCT FillCone FAST topL, LbottomL, RbottomL
  fillP = COPY LbottomR
  CONSTRUCT FillCone FAST topR, LbottomR, RbottomR
  fillLine1 = ILINEPOLAR topB, gridX, 180
  fillLine2 = COPY fillLine1
  CONSTRUCT FillCircleCone FAST
  IPOINT C 260,160, 4,(255,0,0), 8
  cutPCircle = ICIRCLE lineCenter, C
  TEXTWINDOW 400,350, 300,130
  TEXT "General Demonstration of Conic Sections", &HD0D000, -1, 32
  TEXTWINDOW 400,480, 300,200
  TEXT "When the animation finishes, drag Point C (marked red) which will appear in the upper left cone, to change the inclination of the cutting plane."
  WAIT
  INTERACT doSection PACE

MENUITEM "Conic Sections (general) as central projections of a circle"
  CLS &H603000
  TEXTWINDOW 150,150, 450,90
  TEXT "Conic Sections (general) as central projections of a circle", &HFFFF80, &H603000, 40
  TEXTWINDOW 150,240, 450,200
  TEXT "Since a cone is formed by the straight lines from a point to a circle, all conic sections can be interpreted as central projections of a circle. The following construction illustrates this.", &HFFFF80, &H603000
  TEXTWINDOW 150,340, 450,200
  TEXT "Drag Point C (marked red) to change the center of the projection. - Drag Point B (also red) to change the location and size of the circle.", &HFFFF80, &H603000
  MENU
  MENUITEM "Show repeated construction"
    CLS &H603000
    IPOINT C 300,40, 4, &HFF4040, 6
    IPOINT center 300,140
    IPOINT B 350,140, 4, &HFF4040, 6
    LINE proyLine 0,200, 760,200, -1, &H80C0FF
    LINE centerLine 300,0, 300,600, 1, &H80C0FF
    INTERACT iCentralRepeated PACE
  MENUITEM "Show animation"
    CLS &H603000
    IPOINT C 300,40, 4, &HFF4040, 6
    IPOINT center 300,140
    IPOINT B 350,140, 4, &HFF4040, 6
    LINE proyLine 0,200, 760,200, -1, &H80C0FF
    LINE centerLine 300,0, 300,600, 1, &H80C0FF
    INTERACT iCentral PACE
  ENDMENU

MENUITEM "Construction of a conic section from five points"
  CLS &HFFE0C0
  TEXTWINDOW 150,150, 450,90
  TEXT "Construction of a conic section from five points", &H806040, &HFFE0C0, 40
  TEXTWINDOW 150,240, 450,200
  TEXT "A conic section can be defined by five points. The following demonstration constructs a conic from five given points. It is based on Pascal's theorem: 'If the intersections of three pairs of opposite sides of an (irregular) hexagon lie on a straight line, then the six vertices lie on a conic.' - So, if you have five points (a pentagon), you can construct the intersection of one pair of opposite sides. A straight line through this point defines the intersections of the other two pairs, and these in turn define the two missing sides of the hexagon.", -1, &HFFE0C0
  TEXTWINDOW 150,440, 450,200
  TEXT "Drag the five points to the place you wish, then click 'Exit' or press [Esc] to start the construction.", -1, &HFFE0C0
  MENU
  MENUITEM "Show repeated construction"
    CLS &HFFE0C0
    CLS &HFFE0C0
    CONSTRUCT Start5 FAST
    CALL i5Repeated PACE
  MENUITEM "Show animation"
    CLS &HFFE0C0
    CONSTRUCT Start5 FAST
    CALL iConic5 PACE
  ENDMENU

MENUITEM "Ellipse as parallel projection of a circle"
  CLS &HFFC0C0
  TEXTWINDOW 150,150, 450,90
  TEXT "Ellipse as projection of a circle", &HE00000, &HFFC0C0, 40
  TEXTWINDOW 150,240, 450,200
  TEXT "An ellipse can be interpreted as a proportional parallel projection of a circle. The following construction illustrates this.", 0, &HFFC0C0
  TEXTWINDOW 150,340, 450,200
  TEXT "Drag Point C (marked red) vertically to change the eccentricity of the ellipse.", 0, &HFFC0C0
  MENU
  MENUITEM "Show repeated construction"
    CLS &HFFC0C0
    IPOINT C 300,140, 4, &HE00000, 6
    INTERACT iEllipseRepeated PACE
  MENUITEM "Show animation"
    CLS &HFFC0C0
    IPOINT C 300,140, 4, &HE00000, 6
    INTERACT iEllipse PACE
  ENDMENU

MENUITEM "The 'Gardener Ellipse'"
  CLS &H00C000
  TEXTWINDOW 150,150, 450,90
  TEXT "The 'Gardener Ellipse'", &HE0FFC0, &H00C000, 40
  TEXTWINDOW 150,240, 450,200
  TEXT "This construction is so called because you can easily realize it in a garden with a string attached to two stakes (the focal points of the ellipse). It is based on the property of the ellipse that from each point of its periphery, the sum of the distances to the two focal points is the same.", &HFFFFFF, &H00C000
  TEXTWINDOW 150,340, 450,200
  TEXT "Drag Point C (marked red) horizontally to change the eccentricity of the ellipse.", &HFFFFFF, &H00C000
  MENU
  MENUITEM "Show repeated construction"
    CLS &H00C000
    IPOINT C 545,240, 4, &HE00000, 6      'Init. Endpoint of axis
    INTERACT iGardenerRepeated PACE
  MENUITEM "Show animation"
    CLS &H00C000
    IPOINT C 545,240, 4, &HE00000, 6      'Init. Endpoint of axis
    INTERACT iGardener PACE
  ENDMENU

MENUITEM "Ballistic Parable"
  CLS &HA0E0FF
  TEXTWINDOW 150,150, 450,90
  TEXT "A ballistic parable", &H808000, &HA0E0FF, 40
  TEXTWINDOW 150,240, 450,200
  TEXT "Parables can be observed as the form assumed by a string loosely suspended between two points, and as the ideal trajectory of a thrown object if there were no air resistance. The horizontal speed of such an object is constant, and the acceleration of its vertical speed is constant. The following construction demonstrates this as an approximate step-by-step construction.", &H808000, &HA0E0FF
  TEXTWINDOW 150,340, 450,200
  TEXT "Drag point V to change the initial vertical speed, and point A to change the acceleration.",  &H808000, &HA0E0FF
  MENU
  MENUITEM "Show repeated construction"
    CLS &HA0E0FF
    IPOINT show0, 740,500
    IPOINT V, 740, 300, 10, &HFF0000, 20
    IPOINT A, 740, 510, 11, &HFFFF00, 20
    v = ILINE show0, V
    INTERACT iBallisticRepeated PACE
  MENUITEM "Show animation"
    CLS &HA0E0FF
    IPOINT show0, 740,500
    IPOINT V, 740, 300, 10, &HFF0000, 20
    IPOINT A, 740, 510, 11, &HFFFF00, 20
    v = ILINE show0, V
    INTERACT iBallistic PACE
  ENDMENU

MENUITEM "Parable between focal point and line"
  CLS 0
  TEXTWINDOW 150,150, 450,90
  TEXT "A parable from its focal point and guideline", &HFFFF00, 0, 40
  TEXTWINDOW 150,240, 450,200
  TEXT "The following construction is based on the property of the parable, that from all its points the distance to a given point (the focal point) is equal to the distance to a given line (the guideline)." &HFFFFFF, 0
  TEXTWINDOW 150,340, 450,200
  TEXT "Drag the focal point P to change the form of the parable.", &HFFFFFF, 0
  MENU
  MENUITEM "Show repeated construction"
    CLS 0
    LINE guide, 40,0, 40,580, -1, &HFFFFFF
    IPOINT P, 100,280, -1, &HFFFFFF
    INTERACT iParableRepeated PACE
  MENUITEM "Show animation"
    CLS 0
    LINE guide, 40,0, 40,580, -1, &HFFFFFF
    IPOINT P, 100,280, -1, &HFFFFFF
    INTERACT iParable PACE
  ENDMENU

MENUITEM "Hyperbola with parallelograms of same area"
  CLS &H0000FF
  TEXTWINDOW 150,150, 450,90
  TEXT "Construction of a hyperbola by means of parallelograms", &HFFFF00, &H0000FF, 40
  TEXTWINDOW 150,240, 450,200
  TEXT "The following construction is based on the property of the hyperbola, that all parallelograms drawn parallel to the asymptotes, between the center and any point on the hyperbola, have the same area." &HE0E0FF, &H0000FF
  TEXTWINDOW 150,340, 450,200
  TEXT "Drag point B (marked red) to change the inclination of the asymptote, or point C (also red) to change the size of the parallelogram.", &HE0E0FF, &H0000FF
  MENU
  MENUITEM "Show repeated construction"
    CLS &H0000FF
    IPOINT B, 300,140, 4, &HE00000, 6
    IPOINT C, 420,180, 4, &HE00000, 6
    ILINE horizontal 300,140, 600,140
    INTERACT iHyperbolaRepeated PACE
  MENUITEM "Show animation"
    CLS &H0000FF
    IPOINT B, 300,140, 4, &HE00000, 6
    IPOINT C, 420,180, 4, &HE00000, 6
    ILINE horizontal 300,140, 600,140
    INTERACT iHyperbola PACE
  ENDMENU

MENUITEM "'Gardener Hyperbola'"
  CLS &H00C000
  TEXTWINDOW 150,150, 450,90
  TEXT "The 'Gardener Hyperbola'", &HE0FFC0, &H00C000, 40
  TEXTWINDOW 150,240, 450,200
  TEXT "Actually this expression does not exist; but a hyperbola can be constructed in a very similar way to the 'Gardener Ellipse'. The only difference is that with a hyperbola, it is not the sum but the difference between the distances to the two focal points is constant. So it would not be very difficult to invent a device with two strings and two stakes which would draw a hyperbola, similar to the 'Gardener Ellipse'.", &HFFFFFF, &H00C000
  TEXTWINDOW 150,400, 450,200
  TEXT "Drag Point C (marked red) horizontally to change the difference between the distances.", &HFFFFFF, &H00C000
  MENU
  MENUITEM "Show repeated construction"
    CLS &H00C000
    IPOINT C 540,240, 4, &HE00000, 6
    INTERACT iGardenerHRepeated PACE
  MENUITEM "Show animation"
    CLS &H00C000
    IPOINT C 540,240, 4, &HE00000, 6
    INTERACT iGardenerH PACE
  ENDMENU

MENUITEM "Exit Program"
  EXITMENU
REPEATMENU

END

'************** MAIN TITLE *********************************

CONSTRUCTION MainTitle
  IPOINT A,380,60
  IPOINT B,180,360
  IPOINT C,580,360
  fillP = COPY B
  CALL FillConeBlue FAST A,B,C
  IPOINT Conic 100,220, 1,&HE0E000
  IPOINT Sections 600,220, 1,&HE0A000
  ICIRCLE c1 225,220,125
  ICIRCLE c2 475,220,125
REPEAT

CONSTRUCTION FillConeBlue top, lBottom, rBottom
'Needs fillP initialized to lBottom
  baseline = ILINE lBottom, rBottom
  FILL fillP, top, rBottom, (0,0,255), 20
  fillP = IADVANCEON fillP, baseline, 20
REPEAT 20

ANIMATION aTitle
  STEP Conic ALONG c1 -20
  STEP Sections ALONG c2 -20
  MARKPOINT Conic, 64
  MARKPOINT Sections, 64
REPEAT 42

CONSTRUCTION Instructions
  TEXTWINDOW 100,380,500,40
  TEXT "General instructions:", &HFFFF00, 0, 32
  TEXTWINDOW 100,420, 550,65
  TEXT "All following demonstrations show animated or repeated constructions. When a construction is finished, click 'Resume' or press the [Enter] key. Then you can drag certain start points (marked red) to change the appearance of the construction, or click 'Exit' resp. press the [Esc] key to return to the menu.", &HFFFFFF, 0
REPEAT

'**************** GENERAL CONIC SECTIONS DEMO **************

INTERACTION doSection
  CLICKABLE C ALONG cutPCircle
  CONSTRUCT MakeCutline FAST
  IPOINT mP 160,275  ', 2, (0,0,128), 3
  ANIMATE Section FAST
REPEAT  

ANIMATION Section
  STEP mP ALONG cBase, 2
  TRACE RP, BP
  CONSTRUCT SectionPoint
REPEAT 471           'periphery of cBase = 942.5

CONSTRUCTION MakeCutline
  cutLine = ILINE lineCenter, C
  cAux = ICIRCLE lineCenter, C
  cutP2, dummy = ICROSS cutLine, cAux
  cutLine = LINE cutP2, C, -1, 0, 3
  MARKPOINT C
REPEAT

CONSTRUCTION FillCone top, lBottom, rBottom
'To make a gradient fill in a cone. 10 superposed with alpha 1 are already full!
'Needs fillP initialized to lBottom
  baseline = ILINE lBottom, rBottom
  FILL fillP, top, rBottom, (255,255,128), 1
  fillP = IADVANCEON fillP, baseline, 20
REPEAT 14

CONSTRUCTION FillCircleCone
'Needs fillLine1, fillLine2 initialized
  fillLine1 = ILINEPOLAR topB, fillLine1, 15
  fillLine2 = ILINEPOLAR topB, fillLine2, -15
  cFill = IARC fillLine1, fillLine2, 150
  FILL cFill, (255,255,128), 1
REPEAT 11

CONSTRUCTION InitSections
  IPOINT gridM 440,265
  LINEPOLAR gridX, 440,265, 0, -1,(128,128,128)
  LINEPOLAR gridY, 440,265, 270, -1,(128,128,128)  'must go DOWN
  IPOINT topL 160,5
  POINT topB 160,425, 1
  IPOINT topR 600,5
  IPOINT LbottomL 10,255
  IPOINT RbottomL 310,255
  IPOINT LbottomR 450,255
  IPOINT RbottomR 750,255
  guideTop = LINE topL, topR, &H3333, (192,192,192)
  guideBottom = LINE RbottomL, LbottomR, &H3333, (192,192,192)
  LINE bGuideTop 160,275, 440,275, &H3333, (192,192,192)
  LINE bGuideM 160,425, 440,425, &H3333, (192,192,192)
  LINE bGuideBottom 160,575, 440,575, &H3333, (192,192,192)
  LINE vGuideLL 10,255, 10,425, &H3333, (192,192,192)
  vGuideLM = LINE topL, topB, &H3333, (192,192,192)
  LINE vGuideLR 310,255, 310,425, &H3333, (192,192,192)
  LINE vGuideRL 450,255, 450,265, &H3333, (192,192,192)
  LINE vGuideRM 600,5, 600,265, &H3333, (192,192,192)
  LINE vGuideRR 750,255, 750,265, &H3333, (192,192,192)
  CIRCLE cGuideL 440,265, 10, (192,192,192),1, 270, 360
  CIRCLE cGuideL 440,265, 160, (192,192,192),1, 270, 360
  CIRCLE cGuideL 440,265, 310, (192,192,192),1, 270, 360
  LsideL = LINE topL, LbottomL
  RsideL = LINE topL, RbottomL
  LsideR = LINE topR, LbottomR
  RsideR = LINE topR, RbottomR
  baseL = LINE LbottomL, RbottomL
  baseR = LINE LbottomR, RbottomR
  CIRCLE cBase 160,425,150
  IPOINT lineCenter 110,170
REPEAT

CONSTRUCTION SectionPoint
'mP = moving point on circle. RP = Result Point in section.
  radiusB = LINE topB, mP, -1, (0,0,128)
  vertical = ILINEPOLAR mP, gridY, 0
  baseLP = ICROSS vertical, baseL
  vertical = LINE mP, baseLP, -1, (192,192,255)
  radiusL = LINE topL, baseLP, -1, (0,0,128)
  LP = CROSS radiusL, cutLine, 2, (0,0,128), 3
  vertical2 = ILINEPOLAR LP, gridY, 0
  BP = CROSS vertical2, radiusB, 1, (192,0,0)
  vertical2 = LINE LP, BP, -1, (192,192,255)

  onX = ICROSS vertical2, gridX
  aux = ILINE BP, onX
  auxX = ILINEPOLAR onX, aux, 270
    'auxX is like gridX, but with inverted vector if P is ABOVE gridX !!
  pGuideB = ILINEPOLAR BP, gridX, 0
  pGuideY = ICROSS pGuideB, gridY
  pGuideB = LINE BP, pGuideY, -1, (192,192,255)
  pcGuide = CIRCLE gridM, pGuideY, (192,192,255),1, 270, 360
  dummy, pGuideR = ICROSS pcGuide, auxX
      'so we choose the correct point also if P is ABOVE gridX.
  verticalR = ILINEPOLAR pGuideR, gridY, 0
  horizontal = ILINEPOLAR LP, gridX, 0
  RP = CROSS verticalR, horizontal, 1, (0,0,128)
  verticalR = LINE pGuideR, RP, -1, (192,192,255)
  horizontal = LINE LP, RP, -1, (192,192,255)
  P = COPY LP
  MARKPOINT P    'to have a mark "P" in the other cones as well
  P = COPY RP
  MARKPOINT P
  P = COPY BP
  MARKPOINT P
REPEAT

'*************** GENERAL CONIC SECTIONS: PROJECTION OF A CIRCLE ******

CONSTRUCTION InitCentral
  cLine = ILINEPOLAR B, proyLine, 0
  center = ICROSS cLine, centerLine
  c1 = CIRCLE center, B, &H80C0FF
  MARKPOINT B
  MARKPOINT C
  y = ILINEPOLAR center, proyLine, 90.5
    'not exactly 90: projection does not work there.
  dummy, P = ICROSS c1, y
REPEAT

INTERACTION iCentral
  CLICKABLE B, C
  CALL InitCentral FAST
  ANIMATE aCentral FAST
REPEAT

ANIMATION aCentral
'no STEP here; we move P as in the repeated CONSTRUCTION.
  TRACE endP
  CALL centralPoint FAST    
  y = ILINEPOLAR center, y, 1.5
  dummy, P = ICROSS c1, y, -1, &H406080
REPEAT 241

INTERACTION iCentralRepeated
  CLICKABLE B, C
  CALL InitCentral FAST
  CALL centralPoint FAST    'once, to define the first endP
  CALL aCentralRepeated
REPEAT

ANIMATION aCentralRepeated
  CALL Central PACE
REPEAT

CONSTRUCTION Central
  oldEndP = COPY endP
  y = ILINEPOLAR center, y, 5
  dummy, P = ICROSS c1, y
  CALL centralPoint FAST
  result = LINE oldEndP, endP, -1, &HFFFF40, 3
REPEAT 73  

CONSTRUCTION centralPoint
  MARKPOINT P
  radius = LINE C, P, -1, &HA00000
  A = ICROSS radius, proyLine
  radius = LINE C, A, -1, &HA00000
  rLine = ILINEPOLAR P, proyLine, 90
  D = ICROSS rLine, proyLine
  rLine = LINE P,D, -1, &HA00000
  rLine2 = ILINEPOLAR A,proyLine, 90
  endline = LINE C,D, -1, &HA00000
  endP = ICROSS rLine2, endline, 4, &HFFFF40, 3
  rLine2 = LINE A,endP, -1, &HA00000
  endline = LINE C,endP, -1, &HA00000
REPEAT

'************* Conic from 5 points (Pascal's Theorem) ***************

CONSTRUCTION Start5
  IPOINT A, 100,100, 4,&HFF0000,6
  IPOINT B, 130,150, 4,&HFF0000,6
  IPOINT C, 200,160, 4,&HFF0000,6
  IPOINT D, 230,140, 4,&HFF0000,6
  IPOINT E, 240,100, 4,&HFF0000,6
  ILINE x 0,0, 600,0
REPEAT

CONSTRUCTION Init5
  l1 = LINE A,B, -1, &HFFFFFF
  l2 = LINE D,E, -1, &HFFFFFF
  S = ICROSS l1, l2, 1
  MARKPOINT S
  l1 = LINE A,S, -1, &HFFFFFF
  l2 = LINE D,S, -1, &HFFFFFF
  l1 = ILINE C,D
  l2 = ILINE B,C
  'Extend l1 and l2 to 500 pixels on each side
  ICIRCLE limiter 0,0,500
  IMOVECIRCLE limiter, C
  P1,P2 = ICROSS limiter, l1
  P3,P4 = ICROSS limiter, l2
  l1 = LINE P1,P2, -1, &HFFFFFF
  l2 = LINE P3,P4, -1, &HFFFFFF
  MARKPOINT A
  MARKPOINT B
  MARKPOINT C
  MARKPOINT D
  MARKPOINT E
REPEAT

INTERACTION iInit5
  CLICKABLE A,B,C,D,E
  CALL Init5 FAST
REPEAT

CONSTRUCTION Point5
  S1 = ICROSS g, l1
  S2 = ICROSS g, l2
  s1 = LINE S1, A, -1, &HC0C0FF
  s2 = LINE S2, E, -1, &HC0C0FF
  P = CROSS s1,s2, 4,&H0000FF,2
  s1 = LINE S1, P, -1, &HC0C0FF
  s2 = LINE S2, P, -1, &HC0C0FF
REPEAT

ANIMATION aConic5
  TRACE P
  CALL Point5 FAST
  g = LINEPOLAR S,g, 0.3, -1, &HFF80FF
REPEAT 600    'turn only 180 deg. for a line!

'INTERACTION iConic5
ANIMATION iConic5
  CALL iInit5 FAST
  CALL Init5 FAST   'again, to restore construction on screen
  g = ILINEPOLAR S,x,0
  CALL aConic5 FAST
REPEAT 32000

CONSTRUCTION Repeated5
  oldP = COPY P
  g = LINEPOLAR S,g, 3, -1, &HFF80FF
  CALL Point5
  result = LINE oldP, P, -1, &H0000FF, 2
REPEAT 61

ANIMATION i5Repeated
  CALL iInit5 FAST
  CALL Init5 FAST   'again, to restore construction on screen
  g = ILINEPOLAR S,x,0
  CALL Point5 FAST  'to init. the first P
  CALL Repeated5 PACE
  WAIT
REPEAT 32000

'************* Ellipse as parallel projection of a circle ********************

CONSTRUCTION InitEllipse
  POINT Center 300,280
  LINEPOLAR axis 300,280, 0
  LINEPOLAR vAxis 300,280, 90
  CIRCLE c1 300,280, 240
  c2 = CIRCLE Center, C
  MARKPOINT C
  POINT P 300,40     'the moving point around the circle
  oldP3 = COPY C
REPEAT

INTERACTION iEllipse
  CLICKABLE C ALONG vAxis
  CONSTRUCT InitEllipse FAST
  ANIMATE aEllipse FAST
REPEAT

INTERACTION iEllipseRepeated
  CLICKABLE C ALONG vAxis
  CONSTRUCT InitEllipse FAST
  CALL aEllipseRepeated FAST
REPEAT

ANIMATION aEllipseRepeated
  CONSTRUCT Ellipse PACE
REPEAT

CONSTRUCTION Ellipse
  radius = LINE Center, P, -1, &HFFFFFF
  newRadius = ILINEPOLAR Center, radius, 10
  dummy, P2 = ICROSS radius, c2
  vertical = ILINEPOLAR P, axis, 90
  axisP = ICROSS vertical, axis
  vertical = LINE P, axisP, -1, &HFFFFFF
  horizontal = ILINEPOLAR P2, axis, 0
  P3 = ICROSS vertical, horizontal
  horizontal = LINE P2, P3, -1, &HFFFFFF
  result = LINE oldP3, P3, -1, &HE00000, 3
  oldP3 = COPY P3
  dummy, P = ICROSS newRadius, c1
REPEAT 37

CONSTRUCTION EllipsePt   'for ANIMATION
  radius = LINE Center, P, -1, &HFFFFFF
  dummy, P2 = ICROSS radius, c2
  vertical = ILINEPOLAR P, axis, 90
  axisP = ICROSS vertical, axis
  vertical = LINE P, axisP, -1, &HFFFFFF
  horizontal = ILINEPOLAR P2, axis, 0
  P3 = CROSS vertical, horizontal, 2, &HE00000, 3
  horizontal = LINE P2, P3, -1, &HFFFFFF
REPEAT

ANIMATION aEllipse
  STEP P ALONG c1 4
  TRACE P3
  CALL EllipsePt FAST
REPEAT 377   'radius 240x6.2832 = 1508

'*************** "Gardener Ellipse" **********************

CONSTRUCTION InitGardener
'Init. Focal Points
  POINT A  200,240
  POINT B  440,240
  MARKPOINT A
  MARKPOINT B
  axis = ILINE A,B
  c1 = ICIRCLE B, C
  dummy, C = ICROSS c1, axis, 4, &HE00000, 6   'Make sure C is not between focal points!
  MARKPOINT C
  P1 = COPY C
  P2 = COPY C
  C1 = COPY C
  C2 = COPY C
REPEAT

INTERACTION iGardener
  CLICKABLE C ALONG axis
  CALL InitGardener FAST
  CALL aGardenerCircles FAST
REPEAT

INTERACTION iGardenerRepeated
  CLICKABLE C ALONG axis
  CALL InitGardener FAST
  CALL aGardenerRepeated FAST
REPEAT

'We put the repeated construction into an ANIMATION so it has the same
'  behaviour (for the user) as the ANIMATION (waits for 'Resume' after ending).
ANIMATION aGardenerRepeated
  CALL GardenerCircles PACE
REPEAT

CONSTRUCTION GardenerCircles
'Make one circle 15 pix. larger, the other 15 pix. smaller.
  cA = CIRCLE A,C1, &HC06060
  cB = CIRCLE B,C2, &HC06060
  C1 = IADVANCETO C1, A, 15
  C2 = IADVANCETO C2, A, -15
  P3, P4 = ICROSS cA, cB
  line1 = LINE P1,P3, -1, &HFFFF40
  line2 = LINE P2,P4, -1, &HFFFF40
  P1 = COPY P3
  P2 = COPY P4
REPEAT 17        'for AB = 16x15 = 240

ANIMATION aGardenerCircles
  STEP C1, -1,0
  STEP C2, 1,0
  TRACE P1, P2
  cA = CIRCLE A,C1, &HC06060
  cB = CIRCLE B,C2, &HC06060
  P1, P2 = CROSS cA, cB, 2, &HFFFF40, 3
  part1 = LINE A,P1, -1, &H3030FF
  part2 = LINE B,P1, -1, &H3030FF
  part3 = LINE A,P2, -1, &H0000E0
  part4 = LINE B,P2, -1, &H0000E0
REPEAT 241

'************* Ballistic parable *******************************

CONSTRUCTION Ballistic
'requires to init. x to 0, P to 20,500
  v = ILINE show0, V5        'to get DIRECTION of speed (up or down)
  x = ILINEPOLAR P,x, 0
  B = IADVANCEON P,x, 15
  x = LINE P,B, -1, &H505050
  y = ILINEPOLAR B,v, 0
  c1 = ICIRCLE show0,V5
  IMOVECIRCLE c1, B
  dummy, P2 = ICROSS c1, y
  y = LINE B, P2, -1, &H505050
  pLine = LINE P, P2, -1, &HE0E000, 3
  P = COPY P2
'Now subtract a from v
  v2 = ILINE show0, A5
  c1 = ICIRCLE show0, A5
  IMOVECIRCLE c1, V5
  dummy, V5 = ICROSS c1,v2
REPEAT 46

CONSTRUCTION BallisticFast
  v = ILINE show0, V5        'to get DIRECTION of speed (up or down)
  x = ILINEPOLAR P,x, 0
  B = ADVANCEON P,x, 15
  x = LINE P,B, -1, &H505050
  y = ILINEPOLAR B,v, 0
  c1 = ICIRCLE show0,V5
  IMOVECIRCLE c1, B
  dummy, P2 = ICROSS c1, y
  IMOVECIRCLE c1, P2         'advance P2 5 times, to draw this line 5 times longer.
  dummy, P2 = ICROSS c1, y
  IMOVECIRCLE c1, P2
  dummy, P2 = ICROSS c1, y
  IMOVECIRCLE c1, P2
  dummy, P2 = ICROSS c1, y
  IMOVECIRCLE c1, P2
  dummy, P3 = ICROSS c1, y
  y = LINE B, P3, -1, &H505050
  t = LINE P, P3, -1, &H505050
  CALL Div5 P,P3,P2           'now get the REAL P2
  P = COPY P2
'Now subtract a from v
  v2 = ILINE show0, A5
  c1 = ICIRCLE show0, A5
  IMOVECIRCLE c1, V5
  dummy, V5 = ICROSS c1,v2
REPEAT

ANIMATION aBallistic
  'no STEP here; P "steps" along the parable as in the repeated construction.
  TRACE P2
  CALL BallisticFast FAST
REPEAT 230

INTERACTION iBallistic
  CLICKABLE V ALONG v
  CLICKABLE A ALONG v
  CALL aPrepareBallistic FAST
  CALL aBallistic FAST
REPEAT

INTERACTION iBallisticRepeated
  CLICKABLE V ALONG v
  CLICKABLE A ALONG v
  CALL PrepareBallistic FAST
  CALL aBallisticRepeated
REPEAT

ANIMATION aBallisticRepeated
  CALL Ballistic PACE
REPEAT

CONSTRUCTION PrepareBallistic
  vSpeed = LINE show0, V, -1, &HFF0000, 3
  Acceleration = LINE show0, A, -1, &HFFFF00, 3
  MARKNUMBERLINE vSpeed, 5
  MARKNUMBERLINE Acceleration, 5
  MARKPOINT V
  MARKPOINT A, -1, 2
  CALL Div5 FAST show0,V,V5
  CALL Div5 FAST show0,A,A5
  ILINEPOLAR x, 0,0,0
  IPOINT P 20,500
REPEAT

CONSTRUCTION aPrepareBallistic
  CALL PrepareBallistic
    'Now we adjust speed and acceleration so we get the same parable as
    '  in the repeated construction, but with 5 times finer steps:
    '  a2 = a1/25, v2 = v1/5
  CALL Div5 FAST show0, A5, A5
  CALL Div5 FAST show0, A5, A5
  CALL Div5 FAST show0, V5, V5
REPEAT

CONSTRUCTION Div5 A,B,C
  'divides AB by 5 so that AC = result; invisible.
  mainLine = ILINE A,B
  rLine = ILINEPOLAR A, mainLine, 90
  D = IADVANCEON A, rLine, 100
  BB = IADVANCEON A, rLine, 500
  rLine = ILINE BB, B
  pLine = ILINEPOLAR D, rLine, 0
  C = ICROSS pLine, mainLine, 4, &HE0E000, 3
    'give it still a style and color; is used for TRACEing P2!
REPEAT

'************* Parable: between focal point and line ****************

CONSTRUCTION InitParable
  MARKPOINT P
  rLine = ILINEPOLAR P, guide, 90
  R = ICROSS rLine, guide
  M1 = IMIDDLE P,R
  M2 = COPY M1
  P1 = COPY M1
  P2 = COPY M1
REPEAT

INTERACTION iParable
  CLICKABLE P
  CALL InitParable FAST
  CALL aParable FAST
REPEAT

INTERACTION iParableRepeated
  CLICKABLE P
  CALL InitParable FAST
  CALL aParableRepeated FAST
REPEAT

ANIMATION aParableRepeated
  CALL Parable PACE
REPEAT

ANIMATION aParable
  STEP M1, -2,0
  STEP M2, 2,0
  TRACE P3,P4
  CALL ParableMain
  CALL ParableAuxLines P3
  CALL ParableAuxLines P4
REPEAT 300

CONSTRUCTION Parable
  c1 = CIRCLE P,M1, &H808080
  parallel = LINEPOLAR M2, guide, 0, -1, &H808080
  P3, P4 = ICROSS c1, parallel
  line1 = LINE P1,P3, -1, &HFF3030
  line2 = LINE P2,P4, -1, &HFF3030
  P1 = COPY P3
  P2 = COPY P4
  M1 = IADVANCETO M1, P, -15
  M2 = IADVANCETO M2, R, -15
REPEAT 45

CONSTRUCTION ParableMain
  c1 = CIRCLE P,M1, &H808080
  parallel = LINEPOLAR M2, guide, 0, -1, &H808080
  P3, P4 = CROSS c1, parallel, 2, &HFF3030, 3
  part3 = LINE P,P4, -1,&HC0C000
REPEAT

CONSTRUCTION ParableAuxLines P1
  rLine = ILINEPOLAR P1, guide, 90
  R = ICROSS rLine, guide
  a = LINE P,P1, -1,&HE0E000
  b = LINE P1,R, -1, &HE0E000
  MARKNUMBERLINE a, 10
  MARKNUMBERLINE b, 10
  union = LINE P,R, &HF0F0, &H00E000
  mid = MIDLINE P,R, &HF0F0, &H00E000
REPEAT

'************* Hyperbola: parallelograms of same area **********

CONSTRUCTION InitHyperbola
  IPOINT Center 300,300
  IPOINT A, 500,300
  MARKPOINT B
  D = IADVANCETO Center, A, 800    'to make the line long
  E = IADVANCETO Center, A, -800
  asym1 = LINE E,D, -1, &HFFFF00, 2
  D = IADVANCETO Center, B, 800
  E = IADVANCETO Center, B, -800
  asym2 = LINE E,D, -1, &HFFFF00, 2
  c1 = ICIRCLE Center, C
  b = IBISECTOR asym1, asym2
  dummy, C = ICROSS c1, b, 4, &HE00000, 6
        'C = endpoint of parallelogram. Make sure it is in the middle between the two asymptotes, i.e. on the axis.
  MARKPOINT C
  side1 = ILINEPOLAR C, asym2, 0
  Cross1 = ICROSS side1, asym1
  side1 = LINE Cross1, C, -1, &HC0C0C0
  side2 = ILINEPOLAR C, asym1, 0
  Cross2 = ICROSS side2, asym2
  side2 = LINE Cross2, C, -1, &HC0C0C0
  s = ILINE Center, Cross1, -1, &HC0C0C0
  MARKLINE s, -1, 1
  IPOINT Cross3, 765,300   'init. endpoint of parallelogram on asym1
REPEAT

CONSTRUCTION HyperbolaMain   'for the ANIMATION
  CALL HyperbolaPoint FAST
  parallel = ILINEPOLAR Cross3, asym2, 0
  C2 = CROSS guide, parallel, 2, &HFF5050, 3
  parallel2 = ILINEPOLAR C2, asym1, 0
  Cross5 = ICROSS parallel2, asym2
  FILL Cross5, C2, Cross3, &HFFFFC0, 180
  FILL Cross5, Center, Cross3, &HFFFFC0, 180
REPEAT

CONSTRUCTION HyperbolaFirst   'without FILL, just to init. the first C2
  CALL HyperbolaPoint FAST
  parallel = ILINEPOLAR Cross3, asym2, 0
  C2 = CROSS guide, parallel, 2, &HFF5050, 3
  parallel2 = ILINEPOLAR C2, asym1, 0
  Cross5 = ICROSS parallel2, asym2
REPEAT

CONSTRUCTION HyperbolaPoint
  c1 = ICIRCLE Center, Cross1
  IMOVECIRCLE c1, Cross3
  dummy, Cross4 = ICROSS c1, asym1
  s = LINE Cross3, Cross4, -1, &HFF0000, 2
  MARKLINE s, Cross3, Cross4, -1, 1
  guide = ILINE Cross4, C   'do not draw yet; we want to see this line longer.
  ICIRCLE limiter 0,0,500
  IMOVECIRCLE limiter, C
  Limit1, Limit2 = ICROSS limiter, guide
  guide = LINE Limit1, Limit2, &HF8F8, &H00C0C0
     'now this line extends 500 pixels on each side of C.
REPEAT

CONSTRUCTION Hyperbola     'Repeated Construction
  CALL HyperbolaPoint
  parallel = LINEPOLAR Cross3, asym2, 0, -1, &HA0A000
  C3 = ICROSS guide, parallel
  parallel2 = ILINEPOLAR C3, asym1, 0
  Cross5 = ICROSS parallel2, asym2
  parallel2 = LINE C3, Cross5, -1, &HA0A000
  s = LINE Cross3, Cross4, -1, &HFFFF00, 2  'reset to asymptote color!
  Cross3 = ADVANCEON Cross3, asym1, -15
  hypLine = LINE C2, C3, -1, &HFF5050, 3
  C2 = COPY C3
REPEAT 52

ANIMATION aHyperbola
  STEP Cross3, -2, 0
  TRACE C2
  CALL HyperbolaMain
REPEAT 383

INTERACTION iHyperbola
  CLICKABLE B ALONG horizontal
  CLICKABLE C ALONG b
  CALL InitHyperbola FAST
  ANIMATE aHyperbola FAST
REPEAT

INTERACTION iHyperbolaRepeated
  CLICKABLE B ALONG horizontal
  CLICKABLE C ALONG b
  CONSTRUCT InitHyperbola FAST
  ANIMATE aHyperbolaRepeated FAST
REPEAT

ANIMATION aHyperbolaRepeated
  CONSTRUCT HyperbolaFirst FAST  'once, to init. the first C2 !
  CONSTRUCT Hyperbola PACE
REPEAT

'*************** "Gardener Hyperbola" **********************

CONSTRUCTION InitGardenerH
'Init. Focal Points
  POINT A  200,240
  POINT B  440,240
  MARKPOINT A
  MARKPOINT B
  axis = ILINE A,B
  MARKPOINT C
  C1 = COPY A
  C2 = COPY C
REPEAT

CONSTRUCTION InitGardenerHCircles
  cA = CIRCLE A,C1, &HC06060
  cB = CIRCLE B,C2, &HC06060
  cC = COPY cA
  cD = COPY cB
  MOVECIRCLE cC, B, &H6060C0
  MOVECIRCLE cD, A, &H6060C0
REPEAT

INTERACTION iGardenerH
  CLICKABLE C ALONG axis
  CALL InitGardenerH FAST
  CALL InitGardenerHCircles FAST
  CALL aGardenerHCircles FAST
REPEAT

INTERACTION iGardenerHRepeated
  CLICKABLE C ALONG axis
  CALL InitGardenerH FAST
  CALL aGardenerHRepeated FAST
REPEAT

ANIMATION aGardenerHRepeated
  CALL GardenerHCircles PACE
REPEAT

ANIMATION aGardenerHCircles
  STEP cA, 0,0,3
  STEP cB, 0,0,3
  STEP cC, 0,0,3
  STEP cD, 0,0,3
  TRACE P1, P2, P3, P4
  P1, P2 = CROSS cA, cB, 2, &HFFFF40, 3
  P3, P4 = CROSS cC, cD, 2, &H40FFFF, 3
REPEAT 140

CONSTRUCTION GardenerHCircles
'Make both circles 10 pix. larger
  C1 = IADVANCEON C1, axis, -10
  C2 = IADVANCETO C2, B, -10
  cA = CIRCLE A,C1, &HC06060
  cB = CIRCLE B,C2, &HC06060
  P3, P4 = ICROSS cA, cB
'Here is a strange bug. The first of the following lines were not drawn;
'   but only in these circles (to the left).
'   In the blue circles to the right (script lines further below), they are drawn correctly.
  line1 = LINE P1,P3, -1, &HFFFF40
  line2 = LINE P2,P4, -1, &HFFFF40
  P1 = COPY P3
  P2 = COPY P4
  MOVECIRCLE cA, B, &H6060C0
  MOVECIRCLE cB, A, &H6060C0
  P7, P8 = ICROSS cA, cB
  line1 = LINE P5,P7, -1, &H40FFFF
  line2 = LINE P6,P8, -1, &H40FFFF
  P5 = COPY P7
  P6 = COPY P8
REPEAT 45


