'GeoScript: Demonstration of elementary constructions for beginners

TITLE "Elementary geometrical constructions"
WINDOW 640,400

TWINDOW 100,100, 440,280
TEXT "Construction 1: Through a given point, draw a parallel to a given line."
CALL DoWait
CALL InitLineP FAST
CALL Parallel SLOW
WAIT
CLS
TEXT ""

TWINDOW 100,100, 440,280
TEXT "Construction 2: Through a given point, draw a line perpendicular to a given line."
CALL DoWait
CALL InitLineP FAST
CALL RightAngle SLOW
WAIT
CLS
TEXT ""

TWINDOW 100,100, 440,280
TEXT "Construction 3: Through a given point, draw a line in a given angle to a given line."
CALL DoWait
CALL InitLineP FAST
CALL AnglePoint SLOW a, P, result
WAIT
CLS
TEXT ""

TWINDOW 100,100, 440,280
TEXT "Construction 4: Copy a given angle upon another line, originating from a given point P on that line."
CALL DoWait
CALL InitAngleCopy FAST
CALL AngleCopy SLOW a, b, c, P, d
WAIT
END

'***************************************

CONSTRUCTION DoWait
  TWINDOW 100,360, 440,40
  TEXT "Click 'Resume' or press [Enter] key to continue."
  WAIT
  CLS
  TWINDOW 2,400,636,60
REPEAT

CONSTRUCTION Parallel
  TEXT "Put the larger side of the square along the given line. Put the ruler to one of the other sides of the square. Hold the ruler tightly and move the square along the ruler, until its larger side touches P. Draw there the parallel."
  result = LINEPOLAR P, a, 0, -1, (255,0,0)
REPEAT

CONSTRUCTION RightAngle
  TEXT "Put one of the shorter sides of the square along the given line.  Put the ruler to the larger side of the square. Hold the ruler tightly and move the square along the ruler, until its other short side touches P. Draw there the perpendicular line."
  result = LINEPOLAR P,a, 90, -1, (255,0,0)
REPEAT

CONSTRUCTION InitLineP
  LINE a, 10,300, 600,200, -1, (0,0,255)
  POINT P 300,160, -1, (0,0,255)
  MARKPOINT P
REPEAT

CONSTRUCTION AnglePoint line1, P, result
  rLine = ILINEPOLAR P, line1, 90
  R = ICROSS rLine, line1
  TEXT "Draw an auxiliary line in the given angle from any point on the given line."
  auxLine = LINEPOLAR R, line1, 50, -1, (160,160,160)
  MARKANGLE line1, auxLine, "a"
  TEXT "Draw a parallel to the auxiliary line through P."
  result = LINEPOLAR P, auxLine, 0, -1, (255,0,0)
  MARKANGLE line1, result, "a"
REPEAT

CONSTRUCTION InitAngleCopy
  LINE a, 10,300, 200,300, -1, (0,0,255)
  LINE b, 10,300, 200,150, -1, (0,0,255)
  LINE c, 300,200, 500,100, -1, (0,0,255)
  ILINE d, 320,200, 320,100, -1, (0,0,255)
  P = CROSS c, d, -1, (0,0,255)
  MARKPOINT P
REPEAT

CONSTRUCTION AngleCopy a, b, c, P, result
  'Suppose P is on c.
  MARKANGLE a,b, "a"
  origin = ICROSS a,b
  cP = IADVANCEON origin, a, 150
  TEXT "Draw a circle or arc from the origin of the given angle."
  c1 = CIRCLE origin, cP, (160,160,160)
  acp1, acp2 = ICROSS c1, b
  cP2 = IADVANCEON P, c, 150
  TEXT "Draw a circle with the same radius from P."
  c1 = CIRCLE P, cP2, (160,160,160)
  TEXT "Look at the crosspoints of the first arc with the given lines. We will copy the distance between these crosspoints. - Draw an arc from one of these crosspoints to the other."
  c3 = ARC cP, acp2, 45, (160,160,160)
  WAIT 3000
  IMOVECIRCLE c3, cP2
  acp1, acp2 = ICROSS c1, c3
  TEXT "Draw an arc of the same radius from the crosspoint of the second circle with the second line."
  c3 = ARC cP2, acp2, 54, (160,160,160)
  WAIT 1500
  TEXT "Unite the crosspoint of the two arcs with P."
  result = LINE P, acp2, -1, (255,0,0)
  MARKANGLE c, result, "a"
REPEAT
