'GeoScript: "Puzzle" Proof for the Law of Pythagoras

TITLE "Pythagoras Demonstration"

IPOINT D,0,0            'declare type of D used as param. later on

CONSTRUCT mainTitle FAST
TWINDOW 5,10, 620,45
TEXT "The Law of Pythagoras", (255,255,128), (128,128,0), 40
TWINDOW 370,200, 260,100
TEXT "cc = aa + bb",(255,0,0),-1,40
TWINDOW 10,380, 620,50
TEXT "In a rectangular triangle, the square over the hypotenuse is equal to the sum of the squares over the cathetes."
TWINDOW 10,430, 620,20
TEXT "Click on 'Resume' or press [Enter] to see a simple proof."
WAIT
CLS

WINDOW 490,412

CONSTRUCT Init FAST
CONSTRUCT DrawTriangle FAST A1,b1
CONSTRUCT DrawTriangle FAST A2,b2
CONSTRUCT DrawTriangle FAST A3,b3
CONSTRUCT DrawTriangle FAST A4,b4
CONSTRUCT DrawSquare FAST TopL,TopM,ML,M
CONSTRUCT DrawSquare FAST M,MR,BottomM,BottomR
TEXTWINDOW 170,150,80,40
TEXT "b x b", (0,0,100), (190,255,255), 32
TEXTWINDOW 350,340,80,40
TEXT "a x a", (0,0,100), (190,255,255), 32
TEXTWINDOW 490,70, 145,480
TEXT "In a square of side a+b, we put four equal rectangular triangles of cathetes a and b, as drawn at the left. The remaining spaces are the squares over a, resp. over b. - Now we will move the triangles to another location. Press [Enter] to see it."
WAIT
CONSTRUCT EmptySquare FAST TopL,TopR,BottomL,BottomR
ANIMATE MoveTriangles FAST
'After ANIMATE, the drawn triangles disappear from the screen,
'  so we must draw them again.
CONSTRUCT DrawTriangle FAST A1,b1
CONSTRUCT DrawTriangle FAST A2,b2
CONSTRUCT DrawTriangle FAST A3,b3
CONSTRUCT DrawTriangle FAST A4,b4
CONSTRUCT DrawSquare FAST ML2, TopM, BottomM2, MR
TEXT "Now the remaining space is the square over c. Since this is equal to the remaining space in the first picture, cc must be equal to the sum of aa + bb."
TEXTWINDOW 210,220,80,40
TEXT "c x c", (0,0,100), (190,255,255), 32
WAIT
END

'****************************************************

CONSTRUCTION mainTitle
  IPOINT A1 50,310
  IPOINT B1 300,130
  IPOINT C1 300,310
  c = LINE A1,B1, -1,(255,0,0),3
  a = LINE B1,C1, -1,(0,0,255),3
  b = LINE A1,C1, -1,(128,128,0),3
  MARKLINE a, 32
  MARKLINE b, 32
  MARKLINE c, 32
REPEAT

CONSTRUCTION Init
  IPOINT TopL 70,50
  IPOINT TopR 430,50
  IPOINT BottomL 70,410
  IPOINT BottomR 430,410
  'Draw the big square.
  top =    LINE TopL, TopR, -1,-1,3
  left =   LINE TopL, BottomL, -1,-1,3
  right =  LINE TopR, BottomR, -1,-1,3
  bottom = LINE BottomL, BottomR, -1,-1,3
  TopM = IADVANCETO TopL, TopR, 240
  b = ILINE TopL, TopM
  a = ILINE TopM, TopR
  MARKLINE a
  MARKLINE b
  MR = IADVANCETO TopR, BottomR, 240
  b = ILINE TopR, MR
  a = ILINE MR, BottomR
  MARKLINE a, -1,1
  MARKLINE b, -1,1
  ML = IADVANCETO TopL, BottomL, 240
  ML2 = IADVANCETO TopL, BottomL, 120
  BottomM = IADVANCETO BottomL, BottomR, 240
  BottomM2 = IADVANCETO BottomL, BottomR, 120
  M = IADVANCETO TopM, BottomM, 240
  'Starting points and lines for triangles.
  IPOINT A1 310,50, 1,(255,0,0)
  IPOINT A2 430,290, 1,(0,0,255)
  IPOINT A3 70,410, 1,(255,255,0)
  IPOINT A4 310,290, 1,(0,180,0)
  b1 = ILINEPOLAR A1, top, 0
  b2 = ILINEPOLAR A2, top, 180
  b3 = ILINEPOLAR A3, top, 90
  b4 = ILINEPOLAR A4, top, 270
REPEAT

CONSTRUCTION DrawSquare A,B,C,D
  FILL A,B,C, (190,255,255)
  FILL B,C,D, (190,255,255)
REPEAT

CONSTRUCTION EmptySquare A,B,C,D
  FILL A,B,C, &HFFFFFF
  FILL B,C,D, &HFFFFFF
REPEAT

CONSTRUCTION DrawTriangle A, b
  C = IADVANCEON A,b,120
  a = ILINEPOLAR C,b,270
  B = IADVANCEON C,a,240
  FILL A,B,C, -1, 200
  c = ILINE A,B
  MARKLINE c
REPEAT

ANIMATION MoveTriangles
  STEP A2, -8,4
  STEP A3, 0,-8
  STEP A4, 4,0
  b1 = ILINEPOLAR A1, top, 0
  b2 = ILINEPOLAR A2, top, 180
  b3 = ILINEPOLAR A3, top, 90
  b4 = ILINEPOLAR A4, top, 270
  CONSTRUCT DrawTriangle FAST A1,b1
  CONSTRUCT DrawTriangle FAST A2,b2
  CONSTRUCT DrawTriangle FAST A3,b3
  CONSTRUCT DrawTriangle FAST A4,b4
REPEAT 31


