'GeoScript: Regular and Logarithmical Spiral (approximation) Demo.
'Example for a REPEATed CONSTRUCTION.

TITLE "Regular and Logarithmical Spiral"

SPEED 100
TWINDOW 40,40, 560,40
TEXT "Regular Spiral:", (0,192,0), -1, 40
TWINDOW 40,120, 560,150
TEXT "A regular spiral has the same distance between each winding and the next one. A regular spiral appears for example when rolling up a sheet of paper, a ribbon, or another object of even thickness. - The following construction is only an approximation."
TWINDOW 40,300, 560,40
TEXT "Click 'Resume' or press [Enter] to continue."
WAIT

POINT center 340,240
LINEPOLAR guide, 340,240, 0, -1, (190,190,190)
P = IADVANCEON center, guide, -5
x = COPY guide
circleP = COPY P
CALL RegSpiral
WAIT

CLS
TWINDOW 40,40, 560,40
TEXT "Logarithmical Spiral:", (0,0,255), -1, 40
TWINDOW 40,120, 560,150
TEXT "A logarithmical spiral forms in every point the same angle with a radius drawn from the center. This makes the distance from the center increase exponentially (so it would more accurately be called an 'exponential spiral'). Logarithmical spirals appear in nature for example in the shells of snails, and in the forms of certain flowers. - The following construction is only an approximation."
TWINDOW 40,300, 560,40
TEXT "Click 'Resume' or press [Enter] to continue."
WAIT

LINEPOLAR guide, 340,240, 0, -1, (190,190,190)
P = IADVANCEON center, guide, -5
CALL LogSpiral
WAIT
END

CONSTRUCTION LogSpiral
  guide2 = LINEPOLAR center, guide, 15, -1, (190,190,190)
  rect = ILINEPOLAR P, guide, 90
  P2 = ICROSS rect, guide2
  rect = LINE P,P2, -1, (0,0,255)
  P = COPY P2
  guide = COPY guide2
REPEAT 125

CONSTRUCTION RegSpiral
  circleP = IADVANCEON circleP, x, 3 
  c1 = ICIRCLE center, circleP
  guide2 = LINEPOLAR center, guide, 15, -1, (190,190,190)
  dummy, P2 = ICROSS c1, guide2
  result = LINE P,P2, -1, (0,192,0)
  P = COPY P2
  guide = COPY guide2
REPEAT 125
