'GeoScript Tutorial No.11: CHANGING DEFAULT STYLES AND COLORS

'Introducing DEFAULTS, TOOLDEFAULTS

DEFAULTS 0, (255,180,255), (255,255,0), (0,0,128), 3, &HF01, 20, 2, 0, 45
TOOLDEFAULTS 50, 100, 20, (0,255,0), (0,160,0), (160,160,0), (160,0,0), (50,90,50)

CLS 0     'DEFAULTS does NOT change the background which is already drawn!
          'except if you have a SCREEN instruction after DEFAULTS.
WINDOW 640,420
TWINDOW 2,420, 636,40

CALL Init FAST

MENU (255,255,0), (190,0,0)
  MENUITEM "Animate construction automatically"
    TEXT "All angles drawn over the same chord in a circle are equal."
    MENU
      MENUITEM "FAST mode (animating)"
        ANIMATE MoveAngle FAST
      MENUITEM "PACE mode (show construction steps)"
        ANIMATE MoveAngle PACE
      MENUITEM "SLOW mode (show drawing tools)"
        ANIMATE MoveAngle SLOW
    ENDMENU
  MENUITEM "Show construction interactively"
    TEXT "Now drag yourself the point P around the circle."
    MENU
      MENUITEM "FAST mode (animating)"
        INTERACT InteractAngle FAST
      MENUITEM "PACE mode (show construction steps)"
        INTERACT InteractAngle PACE
      MENUITEM "SLOW mode (show drawing tools)"
        INTERACT InteractAngle SLOW
    ENDMENU
  MENUITEM "Exit program"
    EXITMENU
REPEATMENU
END

CONSTRUCTION Init
  CIRCLE c1, 320,200, 170, (0,0,255)
  FILL c1, (0,0,255), 20
  ILINE invisible, 0,310, 600,310
  A,B = CROSS invisible, c1
  chord = LINE A,B
  P = COPY B
REPEAT

ANIMATION MoveAngle
  'Restrict movement of point P to circle c1:
  STEP P ALONG c1, 3
  MARKPOINT P
  a = LINE P,A, -1, (128,0,0)
  b = LINE P,B, -1, (128,0,0)
  c = BISECTOR a,b
  MARKNUMBERANGLE a,b, "a"
REPEAT 250

INTERACTION InteractAngle
  'Restrict movement of point P to circle c1:
  CLICKABLE P ALONG c1
  MARKPOINT P
  a = LINE P,A, -1, (128,0,0)
  b = LINE P,B, -1, (128,0,0)
  c = BISECTOR a,b
  MARKNUMBERANGLE a,b, "a"
REPEAT
