'GeoScript Tutorial No.3: MARKING OBJECTS

'Introducing MARKPOINT, MARKLINE, MARKANGLE, MARKNUMBERANGLE, MARKNUMBERLINE.

'We will draw the same objects as in Tutorial 2,
'  but we will mark some of them with their names.
POINT A, 100,360, -1, &H0000FF
MARKPOINT A, -1, 2    'Default Font Size; Position 2 = bottom.
POINT B, 400,360, -1, &H0000FF
MARKPOINT B, -1, 2
POINT C, 300,85, -1, &H0000FF
MARKPOINT C, 24       'Use a larger font size here.
a = LINE B,C
MARKLINE a, -1, 1     'Position: Right-Bottom
b = LINE A,C
MARKLINE b
c = LINE A,B
MARKLINE c, -1, 1     'Position: Right-Bottom

'Mark the angles of the triangle:
MARKANGLE B,A,C, "a"
MARKANGLE C,B,A, "b"
MARKANGLE A,C,B, "g", 24, 150   'Larger font size and arc radius.

hc = LINEPOLAR C, c, 90, &HF0F   'dashed line
MARKNUMBERANGLE c, hc, "f"
hb = LINEPOLAR B, b, 90, &HF0F

'Signal the crosspoint with a red square.
H = CROSS hc, hb, 4, &HFF0000

'Initialize a new point and line in another place:
POINT X, 400, 280, -1, (0,128,0)
x, Y = STARTLINE X, 0, 180, -1, (0,128,0), 3    'A green line 3 pixels thick.

Z = ADVANCETO X, Y, 50, 2      'A point at 50 pixels from X towards Y.
MARKNUMBERLINE x, X,Z          'Mark distance X-Z.

z = LINEPOLAR Z, x, 30, -1, (0,128,0), 3

WAIT                     'Let user press a button before program exits.
END