'GeoScript Tutorial No.5: NOTABLE LINES IN A TRIANGLE; TEXT OUTPUT.

'Introducing MIDDLE, MIDLINE, BISECTOR, REVERT, SCREEN, WINDOW, TEXTWINDOW, TEXT, CLS

SCREEN 600,460
'Sets the initial window size. 
'  If we omit this (as in the former tutorials),
'  the window will be initialized to 640x480 pixels.

WINDOW 600, 380
'Restricts graphics output to the specified size.

TWINDOW 2,380, 596,60
'Specifies the frame for following TEXT output.
'If there is no TWINDOW/TEXTWINDOW instruction,
'  TEXT instructions will fail.

POINT A = 70,340
POINT B = 530,340
POINT C = 140,40
c = LINE A,B
b = LINE A,C
a = LINE B,C
MARKPOINT A, -1, 2
MARKPOINT B, -1, 2
MARKPOINT C
MARKLINE a
MARKLINE b
MARKLINE c, -1, 1

TEXT "We will join each point of the triangle with the middle of the opposite side. The resulting lines intersect in the gravity center of the triangle.", (0,0,255)

D = MIDDLE B,C
E = MIDDLE A,C
F = MIDDLE A,B
d = LINE A,D, -1, (0,0,255)
e = LINE B,E, -1, (0,0,255)
f = LINE C,F, -1, (0,0,255)
G = CROSS d, e, -1, (0,0,255)
MARKPOINT G

TEXT "Press Resume to continue.", (255,255,0), (160,0,0)
WAIT

TEXT "Now we will draw perpendicular lines from the middle points of each side. They intersect in the center of the circumcircle of the triangle.", (255,0,0)

h = MIDLINE B,C, -1, (255,0,0)
i = MIDLINE A,C, -1, (255,0,0)
j = MIDLINE A,B, -1, (255,0,0)
M = CROSS h,i, -1, (255,0,0)
MARKPOINT M
c1 = CIRCLE M,A, (255,0,0)

TEXT "Press Resume to continue.", (255,255,0), (160,0,0)
WAIT

'Delete Screen content, since we have already a lot of lines on the screen...
CLS

'Now we must draw the triangle again.
c = LINE A,B
b = LINE A,C
a = LINE B,C
MARKPOINT A, -1, 2
MARKPOINT B, -1, 2
MARKPOINT C
MARKLINE a, -1, 1
MARKLINE b
MARKLINE c, -1, 1

TEXT "We bisect each angle of the triangle. The crosspoint of the bisectors is the center of the inscribed circle.", (0,190,0)

d = BISECTOR c,b, -1, (0,190,0)
'We must invert the vector of c, so that its origin is in B
'  and the bisector will be drawn in the correct angle.
REVERT c
e = BISECTOR a,c, -1, (0,190,0)
REVERT a
REVERT b
f = BISECTOR b,a, -1, (0,190,0)

M = CROSS d,e, -1, (0,190,0)
c2 = CIRCLE M, a, (0,190,0)

TEXT "Press Resume to continue.", (255,255,0), (160,0,0)
WAIT

TEXT "The height of the triangle is a perpendicular line from a point to the opposite side. There are three heights and they intersect in a single point.", (160,0,160)

hc = LINEPOLAR C,c, 90, -1, (160,0,160)
ha = LINEPOLAR A,a, 90, -1, (160,0,160)
hb = LINEPOLAR B,b, 90, -1, (160,0,160)
H = CROSS hc, ha, -1, (160,0,160)
MARKPOINT H

TEXT "Press Resume or Exit to end the program.", (255,255,0), (160,0,0)
WAIT
END