'GeoScript Tutorial No.6: PROCEDURE "CONSTRUCTION"

'Introducing CONSTRUCTION, REPEAT, CALL/CONSTRUCT, FAST, PACE, SLOW/TOOLS

SCREEN 600,460
WINDOW 600, 380
TWINDOW 2,380, 596,60

'We initialize these points "invisible",
'so they will not appear initially and will not consume any wait time.
IPOINT A = 70,340
IPOINT B = 530,340
IPOINT C = 140,40

TEXT "Triangle construction in PACE mode. This is the default."

CALL Triangle PACE A,B,C

TEXT "Gravicenter construction in FAST mode. Press Resume to continue."

CALL Gravicenter FAST A,B,C
WAIT

'Clear Screen and draw triangle again:
CLS
CALL Triangle FAST A,B,C

TEXT "Circumcircle construction in SLOW mode."
CALL Circumcircle SLOW A,B,C

CLS

TEXT "Incircle construction in default mode (PACE)."

'Now we initialize our triangle to other points:
POINT X, 100,80, 3,(0,160,0)
POINT Y, 400,80, 3,(0,160,0)
POINT Z, 250,300, 3,(0,160,0)

'No need to call "Triangle" here: "Incircle" draws the lines.
CALL Incircle X,Y,Z

WAIT 4000         'Wait for 4 seconds.
CLS

TEXT "Height construction in SLOW mode."
Markpoint X
Markpoint Y
Markpoint Z
'No need to call "Triangle" here: "Heights" draws the lines.
CONSTRUCT Heights SLOW X,Y,Z

TEXT "Press Resume or Exit to end the program.", (255,255,0), (160,0,0)
WAIT
END

CONSTRUCTION Triangle A,B,C
  c = LINE A,B
  b = LINE A,C
  a = LINE B,C
  MARKPOINT A, -1, 2
  MARKPOINT B, -1, 2
  MARKPOINT C
  MARKLINE a
  MARKLINE b
  MARKLINE c, -1, 1
REPEAT

CONSTRUCTION Gravicenter A,B,C
  D = MIDDLE B,C
  E = MIDDLE A,C
  F = MIDDLE A,B
  d = LINE A,D, -1, (0,0,255)
  e = LINE B,E, -1, (0,0,255)
  f = LINE C,F, -1, (0,0,255)
  G = CROSS d, e, -1, (0,0,255)
  MARKPOINT G
REPEAT

CONSTRUCTION Circumcircle A,B,C
  h = MIDLINE B,C, -1, (255,0,0)
  i = MIDLINE A,C, -1, (255,0,0)
  j = MIDLINE A,B, -1, (255,0,0)
  M = CROSS h,i, -1, (255,0,0)
  MARKPOINT M
  c1 = CIRCLE M,A, (255,0,0)
REPEAT

CONSTRUCTION Incircle A,B,C
  c = LINE A,B
  b = LINE A,C
  a = LINE B,C
  d = BISECTOR c,b, -1, (0,190,0)
  REVERT c
  e = BISECTOR a,c, -1, (0,190,0)
  REVERT a
  REVERT b
  f = BISECTOR b,a, -1, (0,190,0)
  M = CROSS d,e, -1, (0,190,0)
  c2 = CIRCLE M, a, (0,190,0)
REPEAT

CONSTRUCTION Heights A,B,C
  c = LINE A,B
  b = LINE A,C
  a = LINE B,C
  hc = LINEPOLAR C,c, 90, -1, (160,0,160)
  ha = LINEPOLAR A,a, 90, -1, (160,0,160)
  hb = LINEPOLAR B,b, 90, -1, (160,0,160)
  H = CROSS hc, ha, -1, (160,0,160)
  MARKPOINT H
REPEAT
